;(function(global){
	// UglifyJS define hack.  Used for unit testing..
	if (typeof ACCORDIONIZER_NOW === 'undefined') {
	  ACCORDIONIZER_NOW = function () {
	    return +new Date();
	  };
	}

	if (typeof ACCORDIONIZER === 'undefined') {
	  var global = (function(){return this;})();
	}


	var makeAccordionizerObject = function($,tools){

		var anAccordian = function(options){
			var self = this;
			
			self.allButtonJaws = new Object();
			this.initialize = function(){
				self.currentBellow = 0;		
			};
			this.initialize();
			self.whatIsGettingScrolled = options.whatIsGettingScrolled;

			self.accordionParent = options.pageRearrangeEls.accordionParent;
			var ridgeTagName = (self.accordionParent.children().prop('tagName'))
			self.finalRidge = $('<'+ridgeTagName+' class="finalRidge finalRidgeInner ridge"></'+ridgeTagName+'>')
			self.finalRidgeBackdrop = $('<div class="finalRidgeBackdrop"></div>');
			self.finalRidge.append(self.finalRidgeBackdrop);
			self.varFooterBottom = $('<div class="finalRidgeBottom"></div>');
			self.finalRidge.append(self.varFooterBottom)
			
			self.accordionParent.append(self.finalRidge)
			
			self.$parentOfexpansesContainerAndAccordion = self.accordionParent.wrap('<div class="parentOfexpansesContainerAndAccordion" />').parent();
			self.$expansesContainer = $('<div class="expansesContainer"></div>');
			self.$parentOfexpansesContainerAndAccordion.prepend(self.$expansesContainer);
			self.fullWindowMode = self.whatIsGettingScrolled === window;
			var widgetParent;
			if(self.fullWindowMode){
				widgetParent = $('body');
			} else {
				widgetParent = self.whatIsGettingScrolled;
				widgetParent.addClass('accordionizerWidgetParentWithScroll')


				
			}
			widgetParent.addClass('accordionizer')
			self.$accordionOutermost = tools.selectAndMaybeCreate(widgetParent,'accordionOutermost');
			self.$scrollAffectedParent = tools.selectAndMaybeCreate(self.$accordionOutermost,'scrollAffectedParent');
			
			self.$accordionPageHeader = tools.selectAndMaybeCreate(self.$scrollAffectedParent,'accordionPageHeader');
			self.$accordionPageHeader.addClass('ridge');
			self.$accordionPageHeader.append(options.pageRearrangeEls.headerContent)
			
			self.$parentOfMainColumns = tools.selectAndMaybeCreate(self.$scrollAffectedParent,'parentOfMainColumns');
			
			for(var i = 0; i < options.pageRearrangeEls.middleColumnsArray.length; i++){
				options.pageRearrangeEls.middleColumnsArray[i].addClass('ridgeLikeCol')
				self.$parentOfMainColumns.append(options.pageRearrangeEls.middleColumnsArray[i]);
			}
			
			self.$accordionPageFooter = tools.selectAndMaybeCreate(self.$scrollAffectedParent,'accordionPageFooter');
			self.$accordionPageFooter.addClass('ridge');
			self.$accordionPageFooter.append(options.pageRearrangeEls.footerContent)
			
			self.$recycleVessel = $('.expansebuttonPurposerecycleFakeContainer');	
			self.$expansesContainer.append(self.$recycleVessel)
		}







		//++++++++++ end +++++++++++++
		// ACCORDIAN OBJECT
		//++++++++++++++++++++++++++++

		//+++++++++++++++++++++++++++++
		// BUTTONJAW OBJECT
		//++++++++++ start +++++++++++
		anAccordian.prototype.defineSlotObj = function(options){
			var self = this;
			var defaults = {
				openingHeight:0,
				options:{
					ridgeAssignment:{
						$ridge:'',
						ridgeName:''
					},
					expanseAssignment:{
						position:0
					},
					eventInfo:[]
				}
			};
			options = $.extend(true,defaults,options);
			
			if(self.currentBellow != 0){
				if(options.options.ridgeAssignment.ridgeIndex > self.currentBellow.options.ridgeAssignment.ridgeIndex ){
					options.options.ridgeAssignment.$ridge.css(tools.move2YType, tools.move2YValue(self.currentBellow.openingHeight));
				}
			};
			options.options.ridgeAssignment.$ridge.addClass('ridge');
			options.options.expanseAssignment.$expanseSource.addClass('expanse')
			self.$expansesContainer.prepend(options.options.expanseAssignment.$expanseSource);
			return options
		};
		anAccordian.prototype.openOrClose = function(aBellowObj){
			var self = this;
			//
			//requestAnimFrame(function(){
				if(aBellowObj == self.currentBellow){
					self.closing();
				}else{
					self.jawMotor({
						bellowAffected:aBellowObj,
						isAnimated:true,
						onlyFixHeight:false
					})
				}
			//});
		}
		anAccordian.prototype.closing = function(){
			var self = this;
			this.jawMotor({
				bellowAffected:self.currentBellow,
				state: 'closing'
			})
		};

		anAccordian.prototype.customFinalCallback = function(theBellow,situation,options){}
		anAccordian.prototype.returnOpeningHeight = function(theBellow){
			theBellow.options.expanseAssignment.$expanseSource.css('display','block')
			return theBellow.options.expanseAssignment.$expanseSource.outerHeight()
		}
		anAccordian.prototype.modifyOptions = function(theBellow, options){return options;}
		anAccordian.prototype.priorToAnimationCallback = function(theBellow,options){}
		anAccordian.prototype.dynamicContentInjectionX = function(theBellow,options){
			return {
				modifyOptions:function(theBellow, options){return options},
				forBeginning:function(){},
				forUberSelection: $('.void'),
				forAnimeCss:function(){},
				forAddClass:function(){},
				forResetCss:function(){},
				forAbsoluteFinal:function(){},
				forReprime: function(){}
			}
		};
		anAccordian.prototype.jawMotor = function(options){
			var self = this;
			var windowTopPos = 0;
			var fixedTop = 0;
			var fixedLeft = 0;
			var widgetOffsetTop = 0;
			if(!self.fullWindowMode){
				widgetOffsetTop= self.whatIsGettingScrolled.offset().top;
				
				windowTopPos = tools.getYOffset(window);
				//widgetOffsetTop -= windowTopPos
				/*
				console.log('windowTopPos',windowTopPos)
				var containerWidth = self.whatIsGettingScrolled.width();
				var containerHeight = self.whatIsGettingScrolled.height();

				var fixedPlug = $('<div class="asdf">asdf</div>');
				self.whatIsGettingScrolled.after(fixedPlug);
				fixedPlug.css({
					'width':containerWidth+'px',
					'height':containerHeight+'px'
				});
				var fixedOffset = self.whatIsGettingScrolled.offset();
				fixedTop = fixedOffset.top - windowTopPos;
				fixedLeft = fixedOffset.left;
				console.log(fixedOffset)
				self.whatIsGettingScrolled.css({
					'width':containerWidth+'px',
					'height':containerHeight+'px',
					'position':'fixed',
					'top':fixedTop+'px',
					'left':fixedLeft+'px'
				});
				*/
			}

			var theBellow = options.bellowAffected;
			
			var defaults = {
				state:'opening',
				isAnimated: true,
				onlyFixHeight: false
			};
			
			
			options = $.extend(defaults, options);
			if(tools.deviceInfo['gpuAccelFeatures'] == false || 1==2){
				options.isAnimated=false;
			}
			
			options = self.modifyOptions(theBellow, options)
			
			var dynamicContentInjection = self.dynamicContentInjectionX(theBellow,options);
			
			
			
			
			dynamicContentInjection.forBeginning(theBellow, options)
			//update accordian properties for the new current

			//----------------
			//Initialize states
			var isRecycle = false;
			if (self.currentBellow == 0){//if first time opening (no dying expanse) just define dying variable as the clicked Vessel to avoid errors.
				var theRetiringVessel = theBellow.options.expanseAssignment.$expanseSource;
				self.currentBellow = theBellow;
				var isFirstTime = true;
			} else {
				var isFirstTime = false;
				if(
					theBellow.options.ridgeAssignment.ridgeType == 'recycled' && 
					self.currentBellow.options.ridgeAssignment.ridgeType == 'recycled' && 
					theBellow != self.currentBellow && 
					options.state != 'closing'
				){
					//if the old and the new are both tableresults and the swipe is not changing.  So it needs to use the fakeMapContainer
					isRecycle = true;
					var theRetiringVessel = self.$recycleVessel;
					
					
					theRetiringVessel.css({
						'z-index':'99997',
						'display':'none'
					})
					$('.expansebuttonPurposerecycleFakeContainer').html( self.currentBellow.options.expanseAssignment.$expanseSource.html().replace(/id="/g,'id="x'))
				} else {// if it is not just  a tableresults to other tableresults change, or if it is an index change
					var theRetiringVessel = self.currentBellow.options.expanseAssignment.$expanseSource;
				}
			}
			
			

			//Define a bunch of variables
			var whatIsGettingScrolledOffsetTop = 0;
			var windowFrameHeight;
			
			if(self.fullWindowMode){
				windowFrameHeight = window.innerHeight ? window.innerHeight : $(window).height();
			} else {
				windowFrameHeight = self.whatIsGettingScrolled.height();
			}

			//START CODE BLOCK: the order of this is important
			var preShiftOpeningHeight = theBellow.openingHeight;
			if(options.state == 'closing'){
				theBellow.openingHeight = 0;
			} else {
				theBellow.openingHeight = self.returnOpeningHeight(theBellow);
			}
			if(isRecycle == true){//this needed for the shoutbox.  The cached openingHeight is inappropriate when changing bellows.  Causing annoying overlaps on bellows. 
				var preShiftOpeningHeight = theBellow.openingHeight;
			}
			//END CODE BLOCK
			var ridgeLikeCols = $('.ridgeLikeCol').not(self.accordionParent.closest('.ridgeLikeCol'))
			var bellowContainer = self.accordionParent;
			var bellowContainerHeight = (bellowContainer.outerHeight())
			
			var tallestSiblingHeight = 0;
			ridgeLikeCols.each(function(){
				tallestSiblingHeight = Math.max(tallestSiblingHeight,$(this).outerHeight())
			})
			//var leftColHeight = $('.leftCol').outerHeight();
			//var rightColHeight = $('.rightCol').outerHeight();
			//var tallestSiblingHeight = Math.max(leftColHeight,rightColHeight)
			
			var accordionHeightSiiblingDifference = tallestSiblingHeight - bellowContainerHeight;

			var wrapperHeight = self.$accordionOutermost.height();
			var futureWrapperHeight = (wrapperHeight+theBellow.openingHeight)-preShiftOpeningHeight;
			var scrollParentTopPos = tools.getYOffset(self.whatIsGettingScrolled);
			console.log('scrollParentTopPos ' + scrollParentTopPos)
			if(!self.fullWindowMode){
				//scrollParentTopPos -= windowTopPos;
			}
			console.log(scrollParentTopPos)
			
			var windowBottom = (windowFrameHeight + scrollParentTopPos)+widgetOffsetTop;
			console.log(windowBottom)
			var clickedPos = theBellow.options.ridgeAssignment.$ridge.offset().top;
			if(!self.fullWindowMode){
				//clickedPos = ((clickedPos - self.whatIsGettingScrolled.offset().top) - whatIsGettingScrolledOffsetTop) +tools.getYOffset(self.whatIsGettingScrolled)
				//clickedPos = ((clickedPos - windowTopPos) - fixedTop) + (scrollParentTopPos + fixedTop);
				//clickedPos = (clickedPos - windowTopPos)  - fixedTop
				clickedPos = clickedPos + scrollParentTopPos;
			}
			console.log('clickedPos',clickedPos)
			console.log('scrollParentTopPos',scrollParentTopPos)
			var topOverflow = scrollParentTopPos - clickedPos;
			var clickedHeight = theBellow.options.ridgeAssignment.$ridge.outerHeight();
			var clickedOpenedBottomPos = clickedPos + clickedHeight + theBellow.openingHeight;
			var bottomOverflow = clickedOpenedBottomPos - windowBottom;

			theBellow.options.ridgeAssignment.ridgeIndex = theBellow.options.ridgeAssignment.$ridge.index('.ridge');
			var hugeComp = 0;
			if(futureWrapperHeight < windowFrameHeight){
				var windowContentDifference = windowFrameHeight - futureWrapperHeight;
			} else {
				var windowContentDifference = 0;
			}
			var scrollAffectedParentWidth = self.$scrollAffectedParent.width();
			
			accordionPageHeaderHeight = self.$accordionPageHeader.outerHeight()

			//START JAW COMPLEX

			//Determine what the situation is: is the content huge(takes up more than entire screen), does it cause bottom overflow of window, is it above or below the previously opened
			if(((clickedHeight + theBellow.openingHeight) > windowFrameHeight)){
				if(theBellow.options.ridgeAssignment.ridgeIndex <= self.currentBellow.options.ridgeAssignment.ridgeIndex){var situation = 'aboveHuge';};
				if(theBellow.options.ridgeAssignment.ridgeIndex > self.currentBellow.options.ridgeAssignment.ridgeIndex){var situation = 'belowHuge';};
				hugeComp = theBellow.openingHeight - windowFrameHeight + clickedHeight;
			} else {
				if(theBellow.options.ridgeAssignment.ridgeIndex <= self.currentBellow.options.ridgeAssignment.ridgeIndex && clickedOpenedBottomPos <= windowBottom){var situation = 'aboveClear';} 
				if(theBellow.options.ridgeAssignment.ridgeIndex > self.currentBellow.options.ridgeAssignment.ridgeIndex && clickedOpenedBottomPos <= windowBottom){var situation = 'belowClear';} 
				if(theBellow.options.ridgeAssignment.ridgeIndex > self.currentBellow.options.ridgeAssignment.ridgeIndex && clickedOpenedBottomPos > windowBottom){var situation = 'belowOverflow';}
				if(theBellow.options.ridgeAssignment.ridgeIndex <= self.currentBellow.options.ridgeAssignment.ridgeIndex && clickedOpenedBottomPos > windowBottom){var situation = 'aboveOverflow';}
			}

			if(bottomOverflow < 0){
				bottomOverflow = 0
			}
			console.log('topOverflow',topOverflow	)
			if(topOverflow > 0){
				bottomOverflow = -topOverflow;
				hugeComp = 0;
			}
			if(options.state == 'closing'){
				situation = 'closing';
			}
			var scrollToAmount = 0;
			console.log('bottomOverflow',bottomOverflow)
			if(situation=='closing'){
				var amountToShiftToMakeClickedInMiddle = (scrollParentTopPos + ((windowFrameHeight/2)-clickedHeight)) - clickedPos;
				bottomOverflow = futureWrapperHeight < windowBottom - amountToShiftToMakeClickedInMiddle ? futureWrapperHeight - windowBottom : -amountToShiftToMakeClickedInMiddle;
				scrollToAmount = scrollParentTopPos + bottomOverflow;
			}else if(situation=='belowOverflow' || situation=='belowHuge' || situation=='belowClear' ){ 
				var futureVesselPosition = (clickedPos + clickedHeight - self.currentBellow.openingHeight);
				scrollToAmount = scrollParentTopPos + bottomOverflow + -hugeComp + -self.currentBellow.openingHeight;
				if((scrollToAmount + windowFrameHeight) - futureWrapperHeight > 2){
					//If the future bottom of the window will be below the future bottom of the accordian
					//this conditional fixes it when you slide over and the new slide item is so short that there would be a big margin at the bottom.  Instead, it animates and sets into place and scrolls appropriately so the bottom of the according kisses the bottom of the window.  See how the scrollToAmount is defined right above, used in the conditional, and redefined within the conditional.   Repeated below as well.
					if(isFirstTime == false){
						bottomOverflow = bottomOverflow - ((scrollToAmount + windowFrameHeight) - futureWrapperHeight);
						scrollToAmount = scrollParentTopPos + bottomOverflow + -hugeComp + -self.currentBellow.openingHeight;
					}
				}
			}else{//situation == above
				var futureVesselPosition = (clickedPos + clickedHeight);
				console.log(scrollParentTopPos,bottomOverflow,hugeComp)
				scrollToAmount = scrollParentTopPos + bottomOverflow + -hugeComp;
				if(self.currentBellow == theBellow){
					var relevantCachedOpeningHeight = preShiftOpeningHeight;
				} else {
					var relevantCachedOpeningHeight = self.currentBellow.openingHeight;
				}
				if((scrollToAmount + windowFrameHeight) - ((wrapperHeight + theBellow.openingHeight) - relevantCachedOpeningHeight) > 2){
					//this conditional fixes it when you slide over and the new slide item is so short that there would be a big margin at the bottom.  Instead, it animates and sets into place and scrolls appropriately so the bottom of the according kisses the bottom of the window.  See how the scrollToAmount is defined right above, used in the conditional, and redefined within the conditional. Repeated above as well.  
					if(isFirstTime == false){
						bottomOverflow = bottomOverflow - ((scrollToAmount + windowFrameHeight) - ((wrapperHeight + theBellow.openingHeight) - relevantCachedOpeningHeight));
						scrollToAmount = scrollParentTopPos + bottomOverflow + -hugeComp;
					}
				}
			}
			console.log( scrollParentTopPos , bottomOverflow , -hugeComp , -self.currentBellow.openingHeight)
			console.log('self.currentBellow.openingHeight',self.currentBellow.openingHeight)
			if(scrollToAmount < 0){
				//this is for if there's an ugly gap at the top.  neat.
				bottomOverflow = bottomOverflow + scrollParentTopPos;
				scrollToAmount = 0;
			}
			if(!self.fullWindowMode){
				//scrollToAmount -= fixedTop;
				//scrollToAmount += scrollParentTopPos;
				//scrollToAmount = 0;
				//scrollToAmount -= (widgetOffsetTop+scrollParentTopPos);
			}

			bottomOverflow = bottomOverflow - hugeComp;
			

			console.log('bottomOverflow',bottomOverflow)
			console.log('scrollToAmount',scrollToAmount)
			
			var $elDyingAndEarlier = self.accordionParent.find($('.ridge:lt('+self.currentBellow.options.ridgeAssignment.ridgeIndex+'), .ridge:nth('+self.currentBellow.options.ridgeAssignment.ridgeIndex+')')).add(ridgeLikeCols).add(self.$accordionPageHeader);
			var $elClickedAndEarlier = self.accordionParent.find($('.ridge:lt('+theBellow.options.ridgeAssignment.ridgeIndex+'), .ridge:nth('+theBellow.options.ridgeAssignment.ridgeIndex+')')).add(ridgeLikeCols).add(self.$accordionPageHeader);
			var $elClickedAndEarlierNotDying = $elClickedAndEarlier.not($elDyingAndEarlier);
			
			var $elDyingAndLater = self.accordionParent.find($('.ridge:gt('+self.currentBellow.options.ridgeAssignment.ridgeIndex+')').not(self.$accordionPageFooter));
			var $elLaterThanClicked = self.accordionParent.find($('.ridge:gt('+theBellow.options.ridgeAssignment.ridgeIndex+')').not(self.$accordionPageFooter));
			var $elLaterThanClickedNotDying = $elLaterThanClicked.not($elDyingAndLater);
			
			var $elexpanseDiing = theRetiringVessel;
			var $elexpanseOpening = theBellow.options.expanseAssignment.$expanseSource;
			
			
			
			
			function theAnimeCss(){
				//START THEANIMECSS
				
				//END THEANIMECSS
			}
			var whatIsGettingScrolledOffsetToXXXX = -widgetOffsetTop;
			function theResetCss(){
				if((situation=='belowOverflow' || situation=='belowHuge' || situation=='belowClear') && isFirstTime == false){
					$elexpanseDiing.css(tools.move2YType, tools.move2YValue((self.currentBellow.options.expanseAssignment.position + whatIsGettingScrolledOffsetToXXXX)))
					$elexpanseOpening.css(tools.move2YType, tools.move2YValue(((clickedPos + clickedHeight - self.currentBellow.openingHeight) + whatIsGettingScrolledOffsetToXXXX)));
				}else if(situation=='closing'){	
					$elexpanseOpening.css(tools.move2YType, tools.move2YValue((self.currentBellow.options.expanseAssignment.position + whatIsGettingScrolledOffsetToXXXX)))
					$elexpanseDiing.css(tools.move2YType, tools.move2YValue((self.currentBellow.options.expanseAssignment.position + whatIsGettingScrolledOffsetToXXXX)))
				} else if(isFirstTime == false){
					$elexpanseDiing.css(tools.move2YType, tools.move2YValue(((bottomOverflow + self.currentBellow.options.expanseAssignment.position) + theBellow.openingHeight) + whatIsGettingScrolledOffsetToXXXX))
					$elexpanseOpening.css(tools.move2YType, tools.move2YValue((clickedPos + clickedHeight + whatIsGettingScrolledOffsetToXXXX)));
				} else {
					$elexpanseDiing.css(tools.move2YType, tools.move2YValue((bottomOverflow + self.currentBellow.options.expanseAssignment.position) + whatIsGettingScrolledOffsetToXXXX))
					$elexpanseOpening.css(tools.move2YType, tools.move2YValue((clickedPos + clickedHeight + whatIsGettingScrolledOffsetToXXXX)));
				}
				$elClickedAndEarlier.css(tools.move2YType, tools.move2YValue(0));
				$elLaterThanClicked.css(tools.move2YType, tools.move2YValue(theBellow.openingHeight));
				dynamicContentInjection.forResetCss()
				
				
			}

			function absoluteFinal(){
				self.currentBellow = theBellow;
				if(situation != 'closing'){
					theBellow.options.expanseAssignment.position = futureVesselPosition;
					theBellow.options.ridgeAssignment.$ridge.addClass('s-opened').removeClass('s-loading').removeClass('tauchstart');
				} else {
					theBellow.options.ridgeAssignment.$ridge.removeClass('s-opened').removeClass('s-loading').removeClass('tauchstart');
					theBellow.options.expanseAssignment.$expanseSource.css('display','none');
					self.initialize();
				}
					
				self.customFinalCallback(theBellow,situation,options)
				
				
				
				dynamicContentInjection.forAbsoluteFinal()
				
				
				
			}
			
			function reprime(){	
				
				dynamicContentInjection.forReprime()
			
				self.$accordionOutermost.removeClass('jawAnim');
				self.$accordionOutermost.addClass('jawNotMoving');
				
				if(isFirstTime == false){
					theRetiringVessel.css('z-index', 1);
					theRetiringVessel.css({'display':'none'});
					theBellow.options.expanseAssignment.$expanseSource.css('z-index',99);
				}
				if(situation!='closing'){
					theBellow.options.expanseAssignment.$expanseSource.css('display','block');
				} else{
					self.varFooterBottom.css('padding-bottom',(0) + 'px');
				}
				self.$accordionPageFooter.css('padding-bottom',0)
				
				self.$accordionPageFooter.css('top',(0) + 'px');
				
			};
			//EXECUTE NOW
			
			
			function shifty(){
				self.priorToAnimationCallback(theBellow,options)
				if(situation == 'belowClear' || situation == 'belowOverflow' || situation == 'belowHuge'){
					theBellow.options.expanseAssignment.$expanseSource.css('z-index','99')
					theRetiringVessel.css('z-index','97')
				} else {
					theBellow.options.expanseAssignment.$expanseSource.css('z-index','97')
					theRetiringVessel.css('z-index','99')
				}
				self.$expansesContainer.css({
					'padding-top':accordionPageHeaderHeight+'px',
					'margin-top':-accordionPageHeaderHeight+'px'
				})
				self.$accordionPageFooter.css('padding-bottom',Math.max(theBellow.openingHeight,self.currentBellow.openingHeight,preShiftOpeningHeight)+'px')
				if(situation == 'closing'){
					self.$expansesContainer.css('padding-bottom',(preShiftOpeningHeight + windowContentDifference + fixedTop) + 'px');
					self.varFooterBottom.css('padding-bottom',(theBellow.openingHeight) + 'px');
					
				}else{
					self.varFooterBottom.css('padding-bottom',(theBellow.openingHeight) + 'px');
					self.$expansesContainer.css('padding-bottom',(windowContentDifference + Math.max(theBellow.openingHeight,self.currentBellow.openingHeight)) + 'px');
					

					
					//self.varFooterBottom.add(self.$expansesContainer).css('padding-bottom',(theBellow.openingHeight + windowContentDifference) + 'px');
				}
				
				
				theRetiringVessel.css('display','block');
				
				
				if(self.currentBellow != 0){//$('.s-opened').removeClass('s-opened');
					self.currentBellow.options.ridgeAssignment.$ridge.removeClass('s-opened')
				}
			}
			
			/*
			self.finalRidgeBackdrop.css({
				'-webkit-transform': 'scale3d(1,'+(windowFrameHeight/100)+',1)',
				'-moz-transform': 'scale3d(1,'+(windowFrameHeight/100)+',1)',
				'-ms-transform': 'scale3d(1,'+(windowFrameHeight/100)+',1)',
				'-o-transform': 'scale3d(1,'+(windowFrameHeight/100)+',1)',
				'transform': 'scale3d(1,'+(windowFrameHeight/100)+',1)',
			})
			*/
			self.finalRidgeBackdrop.css({'height':windowFrameHeight});


			if(options.isAnimated == true && options.onlyFixHeight == false){
				
				//theAnimeCss()
				//START THE ANIMECSS
				
				var uberSelector = dynamicContentInjection.forUberSelection
					.add($elDyingAndEarlier)
					.add($elClickedAndEarlierNotDying)
					.add($elexpanseOpening)
					.add($elexpanseDiing)
					.add($elLaterThanClicked)
					.add(self.$accordionPageFooter)
				;	

				
				

				//WITHIN THESE CONDITIONALS, VALUES ARE DETERMINED.  THESE VALUES MATCH SELECTORS FOR CSS CHANGES WITH A ONE TO ON RELATIONSHIP.  THE MATCHING SELECTORS ARE WITHIN MATCHING CONDITIONALS BELOW
				if((situation=='belowOverflow' || situation=='belowHuge' || situation=='belowClear') && isFirstTime == false){
					var valexpanseDiing = (bottomOverflow) - self.currentBellow.openingHeight;
					var valDyingAndEarlier = (bottomOverflow)-self.currentBellow.openingHeight;
					var valClickedAndEarlierNotDying = bottomOverflow;
					var valLaterThanClicked = (bottomOverflow) - theBellow.openingHeight;
					if((bellowContainerHeight - self.currentBellow.openingHeight) + theBellow.openingHeight > tallestSiblingHeight){//if bellowContainer after opening is taller than tallestSibling
						if(bellowContainerHeight > tallestSiblingHeight){//bellowContainer was already taller than sibling (and is taller again)
							var valaccordionPageFooter = ((bottomOverflow) - theBellow.openingHeight);
						} else {
							var valaccordionPageFooter = ((bottomOverflow) - theBellow.openingHeight)  + accordionHeightSiiblingDifference;
						}
					} else {
						if(bellowContainerHeight > tallestSiblingHeight){//bellowContainer was previously taller than sibling (and is not taller again)
							var valaccordionPageFooter = ((bottomOverflow) - self.currentBellow.openingHeight)  - accordionHeightSiiblingDifference;
						} else {
							var valaccordionPageFooter = (bottomOverflow) - self.currentBellow.openingHeight;
						}
					}
				}else if(situation=='closing'){
					var valexpanseOpening = bottomOverflow;
					var valexpanseDiing = bottomOverflow;
					var valLaterThanClicked = preShiftOpeningHeight + bottomOverflow;
					var valClickedAndEarlier = bottomOverflow;
					
					if((bellowContainerHeight - preShiftOpeningHeight) - tallestSiblingHeight >= 0){
						var valaccordionPageFooter = bottomOverflow + preShiftOpeningHeight;
					} else {
						if(bellowContainerHeight > tallestSiblingHeight){
							var valaccordionPageFooter = bottomOverflow - accordionHeightSiiblingDifference;
						} else {
							var valaccordionPageFooter = bottomOverflow;
						}
					}
				} else if(isFirstTime == false){ //is abovetype
					if(preShiftOpeningHeight != 0 && preShiftOpeningHeight != theBellow.openingHeight){
						var valLaterThanClickedNotDying = (bottomOverflow) - preShiftOpeningHeight
						var dyingAndLaterAmount = ((bottomOverflow) - theBellow.openingHeight)+preShiftOpeningHeight;
					} else {
						var valLaterThanClickedNotDying = (bottomOverflow) - theBellow.openingHeight;
						var dyingAndLaterAmount = ((bottomOverflow) - theBellow.openingHeight)+self.currentBellow.openingHeight
					}
					var valClickedAndEarlier = bottomOverflow;
					var valexpanseDiing = -theBellow.openingHeight
					var valDyingAndLater = dyingAndLaterAmount;
					if((bellowContainerHeight - self.currentBellow.openingHeight) + theBellow.openingHeight > tallestSiblingHeight){//if bellowContainer after opening is taller than tallestSibling
						if(bellowContainerHeight > tallestSiblingHeight){//bellowContainer was already taller than sibling (and is taller again)
							var valaccordionPageFooter = dyingAndLaterAmount
						} else {
							//bellowContainer was shorter and is taller now
							var valaccordionPageFooter = dyingAndLaterAmount + accordionHeightSiiblingDifference
						}
					} else {
						if(bellowContainerHeight >= tallestSiblingHeight){//bellowContainer was taller than sibling (and is not taller again)
							var valaccordionPageFooter = (bottomOverflow) - accordionHeightSiiblingDifference
						} else {
							var valaccordionPageFooter = 0;
						}
					}	
				} else {
					//FIRST TIME (WHICH IS ABOVETYPE)
					var valClickedAndEarlier = bottomOverflow;
					var valLaterThanClicked = (bottomOverflow) - theBellow.openingHeight;
					if(bellowContainerHeight > tallestSiblingHeight){ //if bellowContainer is already taller than siblings so it can only get even taller on open
						var valaccordionPageFooter = ((bottomOverflow) - theBellow.openingHeight);
					} else {//bellowContainer is shorter than siblings
						if(bellowContainerHeight + theBellow.openingHeight > tallestSiblingHeight){//if it's going to be taller
							var valaccordionPageFooter = ((bottomOverflow) - theBellow.openingHeight) + 
								accordionHeightSiiblingDifference;						
						} else{//bellow container will remain shorter
							var valaccordionPageFooter = 0;
						}
					}	
				}
				
				//MOVED STUFF START
				shifty()
				
				self.$scrollAffectedParent.css({
					'position':'fixed',
					'top':(-scrollToAmount+widgetOffsetTop - windowTopPos) + 'px',
					//'left':'0',
					'width':'100%'
				})
				
				
				//setTimeout(function(){
				
				//setTimeout(function(){
				if(situation=='closing'){
					self.$accordionOutermost.height(futureWrapperHeight + self.currentBellow.openingHeight) //ICS stockbrowser closing bug. Ugh.  I guess it needs plenty of breathing room on the bottom.  Was causing that annoying scroll jump.
					
				} else {
					self.$accordionOutermost.height(futureWrapperHeight)
				}
				
				self.$accordionOutermost.height(5000)
				self.$accordionOutermost.width(scrollAffectedParentWidth)
				self.$scrollAffectedParent.width(scrollAffectedParentWidth)
				
				theResetCss()
				
				
				//MOVED STUFF END
				
				
				
				//HERE WITHIN THESE CONDITIONALS ARE THE MATCHING CSS CHANGES TO THE VALUES DETERMINED WITHIN THE CONDITIONALS ABOVE.  THE PURPOSE OF THIS SPLIT BETWEEN VALUE CALCULATION AND CSS CHANGES IS TO ENSURE CSS ALL FIRES TOGETHER.  THIS MAY BE POINTLESS.  ALSO WHEN READING BELOW, KEEP IN MIND THAT DIFFRENT SITUATION CALL FOR DIFFERENT SELECTORS.
				
				
				$elexpanseDiing.css(tools.move1YType, tools.move1YValue(valexpanseDiing + 0))
				dynamicContentInjection.forAnimeCss()
				if((situation=='belowOverflow' || situation=='belowHuge' || situation=='belowClear') && isFirstTime == false){
					$elexpanseDiing.css(tools.move1YType, tools.move1YValue(valexpanseDiing + 0))
					$elDyingAndEarlier.css(tools.move1YType, tools.move1YValue(valDyingAndEarlier));
					$elClickedAndEarlierNotDying.css(tools.move1YType, tools.move1YValue(bottomOverflow));
					$elLaterThanClicked.css(tools.move1YType, tools.move1YValue(valLaterThanClicked));
					self.$accordionPageFooter.css(tools.move1YType, tools.move1YValue(valaccordionPageFooter));	
				}else if(situation=='closing'){
					$elexpanseOpening.css(tools.move1YType, tools.move1YValue(valexpanseOpening + 0))
					$elexpanseDiing.css(tools.move1YType, tools.move1YValue(valexpanseDiing + 0))
					$elLaterThanClicked.css(tools.move1YType, tools.move1YValue(valLaterThanClicked));
					$elClickedAndEarlier.css(tools.move1YType, tools.move1YValue(valClickedAndEarlier));
					self.$accordionPageFooter.css(tools.move1YType, tools.move1YValue(valaccordionPageFooter));
				} else if(isFirstTime == false){ //is abovetype
					$elLaterThanClickedNotDying.css(tools.move1YType, tools.move1YValue(valLaterThanClickedNotDying));
					$elClickedAndEarlier.css(tools.move1YType, tools.move1YValue(valClickedAndEarlier));
					$elexpanseDiing.css(tools.move1YType, tools.move1YValue(valexpanseDiing + 0));
					$elDyingAndLater.css(tools.move1YType, tools.move1YValue(valDyingAndLater));
					self.$accordionPageFooter.css(tools.move1YType, tools.move1YValue(valaccordionPageFooter));
				} else {//is first time (abovetype also)
					$elClickedAndEarlier.css(tools.move1YType, tools.move1YValue(valClickedAndEarlier));
					$elLaterThanClicked.css(tools.move1YType, tools.move1YValue(valLaterThanClicked));
					self.$accordionPageFooter.css(tools.move1YType, tools.move1YValue(valaccordionPageFooter));
				}
				$elexpanseOpening.css(tools.move1YType, tools.move1YValue((bottomOverflow + 0)));
				
				
				
				setTimeout(function(){
					theBellow.options.ridgeAssignment.$ridge.addClass('s-loading');
					dynamicContentInjection.forAddClass()
					self.$accordionOutermost.addClass('jawAnim');
					self.$accordionOutermost.removeClass('jawNotMoving');

					var i = 0; //so incomingCallback fires only once
					tools.cssTransitioner({
						target: uberSelector,
						cssProperty: tools.move1YType,
						cssValue: tools.move1YValue(0),
						callback: function(){
							i++;
							if(i == 1){
								if(self.fullWindowMode){
									self.whatIsGettingScrolled.scrollTo(0,scrollToAmount);
								} else {
									self.whatIsGettingScrolled.scrollTop(scrollToAmount);
								}
								
								reprime();
								self.$scrollAffectedParent.css({
									'position':'relative',
									'top':'0',
									//'left':'0',
									'width':'auto'
								})
								self.$accordionOutermost.width('auto')
								self.$accordionOutermost.height('auto')

								if(!self.fullWindowMode){
									self.whatIsGettingScrolled.css({
										'position':'',
										'top':'',
										'left':'',
										'height':'',
										'width':''
									});
									//fixedPlug.remove();
								}




								absoluteFinal();
							}
						}
					});
				},100)
				//},1000)
				//},1000)
				//END THE ANIMECSS
			} else if(options.onlyFixHeight == true && 1==1) {
				shifty()
				theResetCss();
				reprime();
				absoluteFinal();
			} else {
				shifty()
				theResetCss()
				if(self.fullWindowMode){
					self.whatIsGettingScrolled.scrollTo(0,scrollToAmount);
				} else {
					self.whatIsGettingScrolled.scrollTop(scrollToAmount);
				}
				reprime();
				self.$scrollAffectedParent.css({
					'position':'relative',
					'top':'0',
					//'left':'0',
					'width':'auto'
				})
				self.$accordionOutermost.width('auto')
				self.$accordionOutermost.height('auto')
				absoluteFinal();
			}
			//requestAnimFrame(function(){});
		}
		console.log(tools)

		return anAccordian;
	}
	//return objInstance;

	if (typeof exports === 'object') {
		// nodejs
		module.exports = makeAccordionizerObject($,tools);
	} else if (typeof define === 'function' && define.amd) {
		// AMD
		define(['jQuery','tools'],function(){
			console.log('accordionizerdefine')
			return makeAccordionizerObject.apply(null,arguments);
		});
	} else if (typeof global.accordionizer === 'undefined') {
		// Browser: Make `Tweenable` globally accessible.
		global.accordionizer = makeAccordionizerObject($,tools);
	}



})(this);