;(function(global){
	// UglifyJS define hack.  Used for unit testing.
	if (typeof TOOLS_NOW === 'undefined') {
	  TOOLS_NOW = function () {
	    return +new Date();
	  };
	}

	if (typeof TOOLS === 'undefined') {
	  var global = (function(){return this;})();
	}
	var makeTools = function($){
		var obj = function(){	
			//---------
			//DEVICE INFO
			//----------
			this.deviceInfo = (function(){ 	
				//++++++++++++++++++++++++++++++++++++++++++++++++++++
				//BROWSER DETECT : css3Prefix detect, useragent detect, css customization per browser

				var deviceInfo = {};
				function has3d(){var e=document.createElement("p"),t,n={webkitTransform:"-webkit-transform",OTransform:"-o-transform",msTransform:"-ms-transform",MozTransform:"-moz-transform",transform:"transform"};document.body.insertBefore(e,null);for(var r in n){if(e.style[r]!==undefined){e.style[r]="translate3d(1px,1px,1px)";t=window.getComputedStyle(e).getPropertyValue(n[r])}}document.body.removeChild(e);return t!==undefined&&t.length>0&&t!=="none"}//http://stackoverflow.com/questions/5661671/detecting-transform-translate3d-support

				deviceInfo['gpuAccelFeatures'] = has3d();

				deviceInfo['vendorPrefix'] = function (){ 
					if('result' in arguments.callee) return arguments.callee.result;
					var regex = /^(Moz|Webkit|Khtml|O|ms|Icab)(?=[A-Z])/;
					var someScript = document.getElementsByTagName('script')[0]; 
					for(var prop in someScript.style){
						if(regex.test(prop)){// test is faster than match, so it's better to perform that on the lot and match only when necessary
							return arguments.callee.result = prop.match(regex)[0];
						}
					}
					// Nothing found so far? Webkit does not enumerate over the CSS properties of the style object. However (prop in style) returns the correct value, so we'll have to test for the precence of a specific property
					if('WebkitOpacity' in someScript.style) {return arguments.callee.result = 'Webkit';}
					if('KhtmlOpacity' in someScript.style) {return arguments.callee.result = 'Khtml';}
					return arguments.callee.result = '';
				}

				var $body = $('body')
				if(navigator.userAgent.match(/Apple/i) && navigator.userAgent.match(/Window/i) && !navigator.userAgent.match(/Chrome/i)){
					deviceInfo['winSafariBrowser'] = true;
					$body.addClass('deviceInfoWinSafari')
				} else {
					deviceInfo['winSafariBrowser'] = false;
					$body.addClass('deviceInfoNotWinSafari')
				}
				if ($.browser.mozilla ) {
					deviceInfo['mozillaBrowser'] = true;
					$body.addClass('deviceInfoMozilla')
				} else {
					deviceInfo['mozillaBrowser'] = false;
					$body.addClass('deviceInfoNotMozilla')
				}
				if(navigator.userAgent.match(/iPod/i) || navigator.userAgent.match(/iPhone/i) || navigator.userAgent.match(/iPad/i))
				{ 
					deviceInfo['iOsRev2Device'] = true;
					$body.addClass('deviceInfoIOs')
				} else {
					deviceInfo['iOsRev2Device'] = false;
					$body.addClass('deviceInfoNotIOs')
				}

				if(navigator.userAgent.match(/Android/i)){
					deviceInfo['androidXDevice'] = true;
					$body.addClass('deviceInfoAndroid')
				}else{
					deviceInfo['androidXDevice'] = false;
					$body.addClass('deviceInfoNotAndroid')
				} 
				if(navigator.userAgent.match(/android 3/i) || navigator.userAgent.match(/Android 4/i)){
					deviceInfo['laterxAndroid'] = true;
					$body.addClass('deviceInfoLaterAndroid')
					if(navigator.userAgent.match(/Chrome/i)){
						deviceInfo['laterAndroidxChrome'] = true;
						$body.addClass('deviceInfoLaterAndroidChrome')
					} else{
						deviceInfo['laterAndroidxChrome'] = false;
						$body.addClass('deviceInfoNotLaterAndroidChrome')
					}
				} else {
					deviceInfo['laterxAndroid'] = false;
					$body.addClass('deviceInfoNotLaterAndroid')
					deviceInfo['laterAndroidxChrome'] = false;	
					$body.addClass('deviceInfoNotLaterAndroidChrome')
				}/**/
				if(deviceInfo['androidXDevice'] == true && deviceInfo['laterxAndroid'] == false){
					deviceInfo['glitchyxAndroid'] = true;
					$body.addClass('deviceInfoGlitchyAndroid')
				} else {
					deviceInfo['glitchyxAndroid'] = false;
					$body.addClass('deviceInfoNotGlitchyAndroid')
				}
				if(navigator.userAgent.match(/MSIE/i)){
					deviceInfo['iexBrowser'] = true;
					deviceInfo['gpuAccelFeatures'] = false;
					$body.addClass('deviceInfoIe')
				} else {
					deviceInfo['iexBrowser'] = false;
					$body.addClass('deviceInfoNotIe')
				}
				if(!$.browser.mozilla && !$.browser.webkit){
					deviceInfo['gpuAccelFeatures'] = false;
				} else {
					$body.addClass('gpuAccelFeatures')
				}	
				return deviceInfo;
			})()	

			//----
			//END DEVICE INFO
			//------			
		};
		var objInstance = new obj();
		
		//-------
		//MONKEY PATCHES
		//------
		//http://paulirish.com/2011/requestanimationframe-for-smart-animating/
		//http://jsfiddle.net/jTZCy/
		// requestAnim shim layer by Paul Irish
		window.requestAnimFrame = (function(){
		  return  window.requestAnimationFrame       || 
				  window.webkitRequestAnimationFrame || 
				  window.mozRequestAnimationFrame    || 
				  window.oRequestAnimationFrame      || 
				  window.msRequestAnimationFrame     || 
				  function(/* function */ callback, /* DOMElement */ element){
					window.setTimeout(callback, 1000 / 60);
				  };
		})();
		
		
		//**********************
		//GET PAGEYOFFSET BECAUSE IE IS STUPID
		//**********************
		obj.prototype.getYOffset = function($el){
			var posY;
			if(typeof $el === 'undefined' || $el === window ){
				if(typeof(window.pageYOffset)=='number') {
				   posY=window.pageYOffset;
				}
				else {
				   posY=document.documentElement.scrollTop;
				}
			} else {
				posY = $el[0].scrollTop;
			}
			return posY;
		}
		
		//************************
		// CSS TRANSITION CALLBACK HELPER 
		obj.prototype.cssTransitioner = function(cssTransObj,transitionSpeed){
			
			cssTransObj.target.bind("transitionend webkitTransitionEnd oTransitionEnd otransitionend MSTransitionEnd",function(event){
				if(cssTransObj.target.is($(event.target))){//a selector of more than one jqueryObject might be passed.  Also, there could be transitions on child element (like buttons) and child element transitions trigger the callback.  So this conditional confirms that it's the targeted element itself that gets listened to and this works for a selector of multiple elements.
				//if(event.target == cssTransObj.target[0]){
					//(event.originalEvent.propertyName + ' - - - ping')
					if(event.originalEvent.propertyName.indexOf("transform") !=-1){//unintended css events leaked through, messing up sequence.  COnditional here fixes it.  Might use property name as argument so this is customizable.
						cssTransObj.target.unbind('transitionend webkitTransitionEnd oTransitionEnd otransitionend MSTransitionEnd');
						cssTransObj.callback();	
					}
				}
			})
			
			requestAnimFrame(function(){
				cssTransObj.target.css(cssTransObj.cssProperty,cssTransObj.cssValue)
			});
		}
		
		obj.prototype.selectAndMaybeCreate = function($parent,className){
			var $myel = 
				$('> .'+className, $parent).length ? 
				$('> .'+className, $parent) : 
				$('<div class="'+className+'"></div>').appendTo($parent);
			return $myel;
		}
		
		obj.prototype.maybeCreateAndSelect = function($parent,className){
			var $myel = 
				$('> .'+className, $parent).length ? 
				$('.void') : 
				$('<div class="'+className+'"></div>').appendTo($parent);
			return $myel;
		}

		
		
		
		
		//Different devices use different CSS to do jaw movement.  CSS properties and value are abstracted and assigned below.
		if (objInstance.deviceInfo['gpuAccelFeatures'] == true) {
			objInstance.move1YType = '-' + objInstance.deviceInfo['vendorPrefix']() + '-transform';
			objInstance.move1YValue = function(val){
				if(val == 'none' || val == '0'){
					if(objInstance.deviceInfo['androidXDevice'] == false || objInstance.deviceInfo['laterxAndroid'] == true){
						return 'translate3d(0,'+(0)+'px,0)'
					} else {
						return 'none'
					}
				}else{
					return 'translate3d(0,'+(val)+'px,0)'
				}
			}
			objInstance.move1XType = '-' + objInstance.deviceInfo['vendorPrefix']() + '-transform';
			objInstance.move1XValue = function(val){
				if(val == 'none' || val == '0'){
					if(objInstance.deviceInfo['androidXDevice'] == false || objInstance.deviceInfo['laterxAndroid'] == true){
						return 'translate3d('+ (0) + 'px, 0, 0)'
					} else {
						return 'none'
					}
				}else{
					return 'translate3d('+ (val) + 'px, 0, 0)'
				}
			}
			objInstance.move2YType = 'top';
			objInstance.move2YValue = function(val){
				if(val == 'none'){
					return 'auto';
				}else{
					return val + 'px';
				}
			}
			objInstance.move2XType = 'left';
			objInstance.move2XValue = function(val){
				if(val == 'none'){
					return 'auto';
				}else{
					return val + 'px';
				}
			}
		} else {
			objInstance.move1YType = 'top';
			objInstance.move1YValue = function(val){
				if(val == 'none'){
					return 'auto';
				}else{
					return val+'px';
				}
			}
			objInstance.move1XType = 'left';
			objInstance.move1XValue = function(val){
				if(val == 'none'){
					return 'auto';
				}else{
					return val+'px';
				}
			}
			objInstance.move2YType = 'top';
			objInstance.move2YValue = function(val){
				if(val == 'none'){
					return 'auto';
				}else{
					return val + 'px';
				}
			}
			objInstance.move2XType = 'margin-left';
			objInstance.move2XValue = function(val){
				if(val == 'none'){
					return 'auto';
				}else{
					return val + 'px';
				}
			}
		}
		return objInstance;
	};


	if (typeof exports === 'object') {
		// nodejs
		module.exports = makeTools($);
	} else if (typeof define === 'function' && define.amd) {
		// AMD
		define(['jQuery'],function () { 
			return makeTools.apply(null,arguments);
		});
	} else if (typeof global.tools === 'undefined') {
		// Browser: Make `Tweenable` globally accessible.
		global.tools = makeTools($);
	}



})(this);